var $request = (function request() {
    var sSearch = location.search;
    var oParam = {};
    sSearch = sSearch.substr(1, sSearch.length);
    var params = sSearch.split("&");
    for (var i = 0; i < params.length; i++) {
        var param = params[i].split("=");
        var key = param[0];
        var value = decodeURIComponent(param[1]);
        if (key in oParam) {
            (oParam[key].constructor == Array) ? oParam[key].push(value) : oParam[key] = [oParam[key], value];

        } else {
            oParam[key] = value;
        }
    }
    var fn = (function (sParamName) {
        return (oParam[sParamName]) ? oParam[sParamName] : ""
    });

    fn.get = function () {
        return oParam;
    };
    return fn;
})();

var QtiConfig = {
    responseOption: {
        refPath: '',//xml中表达式${ref-path}的实际值,默认值''
        showNum: true,//题目序号是否关闭
        showCompositeChildNum: true, //复合题子题序号是否显示
        showTitleArea: true,//是否渲染题干区，默认值true
        hideAnswerArea: false,//隐藏答案区域，默认false
        showAnswerArea: true,//渲染答案区域，默认值true
        showHint: false, //是否渲染答案提示，默认值true
        showLock: false, //是否锁定答案区,锁定后将不能再答题，默认值false
        lockMedia: false, //是否锁定多媒体
        showAnswer: true,//渲染当前的作答前情况，默认值false
        showSubSequence: true,//是否显示题目内序号（目前填空题生效）
        showCheckedAnswer: false,//渲染当前选中的答案，默认值false
        platForm: '',//接入平台,默认空，目前有：pptshell\statis
        showCorrectAnswer: false, //渲染正确的答案，默认值false
        showStatisAnswer: false,//渲染统计答案，目前支持填空题
        showMedia: true,//是否渲染多媒体，默认值true
        randomSeed: [],//选项排序种子数组(0~29不重复的随机数组)，默认[]
        expectWidth: 0,//期望答案区域宽，目前仅支持拼图题
        expectHeight: 0,//期望答案区域宽，目前仅支持拼图题
        unifyTextEntry: true,//统一填空题结构,将普通填空题处理为复合题中填空结构
        showQuestionName: true,//在题干中显示题目类型
        showCompositeSeparate: true,//显示复合题题干、内容分割栏
        skin: 'elearning'//皮肤：'wood'/'elearning' ,默认wood
    },

    analyseOption: {
        refPath: '',//xml中表达式${ref-path}的实际值,默认值''
        showNum: true,//
        showCompositeChildNum: true, //
        showTitleArea: true,//是否渲染题干区，默认值true
        hideAnswerArea: false,//隐藏答案区域，默认false
        showAnswerArea: true,//渲染答案区域，默认值true
        showHint: false, //是否渲染答案提示，默认值true
        showLock: true, //是否锁定答案区,锁定后将不能再答题，默认值false
        lockMedia: false, //是否锁定多媒体
        showAnswer: false,//渲染当前的作答前情况，默认值false
        showSubSequence: true,//是否显示题目内序号（目前填空题生效）
        showCheckedAnswer: true,//渲染当前选中的答案，默认值false
        platForm: '',//接入平台,默认空，目前有：pptshell\statis
        showCorrectAnswer: false, //渲染正确的答案，默认值false
        showStatisAnswer: false,//渲染统计答案，目前支持填空题
        showMedia: true,//是否渲染多媒体，默认值true
        randomSeed: [],//选项排序种子数组(0~29不重复的随机数组)，默认[]
        expectWidth: 0,//期望答案区域宽，目前仅支持拼图题
        expectHeight: 0,//期望答案区域宽，目前仅支持拼图题
        unifyTextEntry: true,//统一填空题结构,将普通填空题处理为复合题中填空结构
        showQuestionName: true,//在题干中显示题目类型
        showCompositeSeparate: true,//显示复合题题干、内容分割栏
        skin: 'elearning'//皮肤：'wood'/'elearning' ,默认wood
    }
};
var TAG = "ele-exp/qti: ";

window.QtiPlayer.setLoggerLevel('debug');

var mPosition = Number($request('i'));
console.log(TAG + 'createPlayer mPosition: ' + mPosition);

var mQtiType = loadQtiType();
var mQtiOption = loadQtiOption(mQtiType);

var qtiplayer = window.QtiPlayer.createPlayer(mQtiOption);

initPlayer();

function initPlayer() {
    loadQuiz(mPosition);
}
/**
 * 加载qti作答类型
 */
function loadQtiType() {
    var type = parseInt(JsDataBridgeApi.getQtiType(), 10);
    console.log(TAG + 'qtiType: ' + type);
    return type;
}

/**
 * 加载qti配置
 * @param qtiType 类型
 */
function loadQtiOption(qtiType) {
    var option;
    if (isResponseType(qtiType)) {
        option = QtiConfig.responseOption;
    } else {
        option = QtiConfig.analyseOption;
    }
    var quizPositionIndicator = JsDataBridgeApi.getQuizPositionIndicator(mPosition);
    if (quizPositionIndicator != null) {
        option['showNum'] = true;
        option['sequenceNumber'] = quizPositionIndicator;
    } else {
        option['showNum'] = false;
    }

    option['showCompositeSeparate'] = JsDataBridgeApi.showCompositeSeparate();
    option['lang'] = JsDataBridgeApi.getLangCode();
    return option;
}

/**
 * 是否是作答模式
 * @param qtiType 模式类型
 */
function isResponseType(qtiType) {
    switch (qtiType) { //转成16进制的数
        case 0x01: //正常作答
        case 0x02: //回顾题目
        case 0x03: //做一题看一题答案
        case 0x04: //闯关模式
        case 0x05: //跳转作答模式
            return true;
        case 0x10: //错题解析
        case 0x11: //全部解析
        case 0x13: //回顾解析，只查看用户作答的答案，没有正确答案，没有解析
        case 0x14: //已做答题目解析
            return false;
    }
    return false;
}
function mathjaxRender(quizJson) {
    if ((window.unsafeWindow == null ? window : unsafeWindow).MathJax == null) {
        var flag = /<latex.*?(?:>|\/>)/i.test(quizJson);
        // var latex = document.getElementsByTagName('latex');
        if (flag) {
            var script = document.createElement("script");
            script.type = "text/javascript";
            script.src = "file:///android_asset/exp/qti-player/lib/mathjax/MathJax.js?config=TeX-AMS-MML_SVG-full,local/local";
            document.getElementsByTagName("head")[0].appendChild(script);
        }
    }
}
/**
 * 加载题目
 * @param position 题目位置
 */
function loadQuiz(position) {
    var quizJson = JsDataBridgeApi.getQuizJson(position);

    //以基准字号增加2像素
    qtiplayer.setFontSize({
        diff: JsDataBridgeApi.getFontSizeDiff()
    })

    qtiplayer.load(quizJson, function () {
        mathjaxRender(quizJson);
        var quizScoreJson = JsDataBridgeApi.getQuizScoreJson(position);
        console.log(TAG + 'quizScoreJson=' + quizScoreJson);
        if (quizScoreJson != null) {
            qtiplayer.setTitleExtras(JSON.parse(quizScoreJson));
        }

        qtiplayer.render('qtiplayer-view', mQtiOption, function () {
            console.log(TAG + 'loadQuizSuccess position: ' + position);

            var autoChangePage = JsDataBridgeApi.checkAutoChangePage(position);
            var extraSettings = checkMust();

            //loadQuizSuccess 方法有依赖 onSupportQuizType 的结果
            JsNotifyApi.onLoadQuizFinish(position, isSupportQuizType(), autoChangePage, JSON.stringify(extraSettings), getUploadFileAllowable());

            loadUserAnswer(mPosition);
            if (!isResponseType(mQtiType)) {
                if (noShowMarkResult(mQtiType)) {
                    qtiplayer.setLock(true, false);
                } else {
                    qtiplayer.showErrorOrCorrectAnswer();
                }
            }

            addUserAnswerChangeListener(autoChangePage);
            if (isResponseType(mQtiType)) {
                setLoggerListener();
            } else {
                if (!noShowMarkResult(mQtiType)) {
                    showExplain();
                    showComments();
                }
            }
        });
    });
}

function getUploadFileAllowable() {
    var assessmentModel = qtiplayer.getAssessmentModel();
    console.log(TAG + 'assessmentModel: ' + JSON.stringify(assessmentModel));
    var modelMap = assessmentModel['modelMap'];
    for (var key in modelMap) {
        var model = modelMap[key];
        var answerLimit = model['answerLimit'];
        if (answerLimit != null) {
            if (answerLimit['uploadFileAllowable']) {
                return true;
            }
        }
    }
    return false;
}

function checkMust() {
    var extraSettings = Object.create(null);
    var assessmentModel = qtiplayer.getAssessmentModel();
    var modelMap = assessmentModel['modelMap'];
    for (var key in modelMap) {
        var model = modelMap[key];
        extraSettings[key] = false;
        var addtionalAnswer = model['addtionalAnswer'];
        if (addtionalAnswer != null) {
            var isMust = addtionalAnswer['isMust'];
            if (isMust != null) {
                extraSettings[key] = isMust;
            }
        }
    }
    return extraSettings;
}

/**
 * 不显示批改结果
 * @param qtiType
 * @returns {boolean}
 */
function noShowMarkResult(qtiType) {
    return qtiType == 0x13 || qtiType == 0x14;
}

/**
 * 加载用户答案
 * @param position 题目位置
 */
function loadUserAnswer(position) {
    var userAnswerJson = JsDataBridgeApi.getUserAnswerJson(position);
    if (userAnswerJson == null || userAnswerJson == "") {
        return;
    }
    console.log(TAG + 'loadUserAnswer: ' + userAnswerJson);
    qtiplayer.setAnswer(JSON.parse(userAnswerJson));
    qtiplayer.showAnswer();
    if (isResponseType(mQtiType)) {
        qtiplayer.isValid();
    }

}

/**
 * 显示解析区域
 */
function showExplain() {
    var exampleOption = {
        showUserAnswer: false,//不显示用户作答
        showCheckedAnswer: false,//不标识用户作答是否正确，正确绿色，错误红色
        showCorrectAnswer: false,//不显示正确答案
        showHint: false,//显示提示
        showAnalyse: true//显示解析
     };
    var extrasOption = {
        showUserAnswer: true,//显示用户作答
        showCheckedAnswer: true,//是否用标识用户作答是否正确，正确绿色，错误红色
        showCorrectAnswer: true,//显示正确答案
        showHint: false,//显示提示
        showAnalyse: true//显示解析
    };
    qtiplayer.showDefaultExtras(mQtiType == 0x20 ? exampleOption : extrasOption);

    var explainJson = JsDataBridgeApi.getExplainJson(mPosition);
    console.log(TAG + "explainJson=" + explainJson);

    var explain = JSON.parse(explainJson);
    for (var index in explain) {
        var subExplain = explain[index];
        qtiplayer.appendToExtras(subExplain["extra_html"], subExplain["model_id"]);
    }
}

function getQtiAnswer(){
    var answer= qtiplayer.getAnswer();
    var str = JSON.stringify(answer);
    JsNotifyApi.onUserAnswerChange(mPosition, str, false, true);
//    window.webkit.messageHandlers.getQtiAnswerNative.postMessage(str);
}

function getHint(originHint){
    var model= qtiplayer.getAssessmentModel();
    var str = JSON.stringify(model);
    var originStr = JSON.stringify(originHint);
    JsNotifyApi.getHint(str, originStr);
}

/**
 * 显示评语
 */
function showComments() {
    var commentJson = JsDataBridgeApi.getCommentJson(mPosition);
    console.log(TAG + "commentJson=" + commentJson);

    if(commentJson == null || commentJson == ""){
        return;
    }

    var comment = JSON.parse(commentJson);
    qtiplayer.appendToExtras(comment["extra_html"], comment["model_id"]);
}

/**
 * 添加答案变化监听器
 */
function addUserAnswerChangeListener(autoChangePage) {
    qtiplayer.answerOnChange(function (answer) {
        console.log(TAG + 'answerOnChange');
        var answerJson = JSON.stringify(answer);
        var isValid = true;
        var validResult = qtiplayer.isValid();
        if (validResult != null) {
            isValid = validResult['result'];
        }
        JsNotifyApi.onUserAnswerChange(mPosition, answerJson, autoChangePage, isValid);
    });
}

/**
 * 本地日志打印
 */
function setLoggerListener() {
    QtiPlayer.setLoggerListener(function (msg) {
        JsNotifyApi.printLocalLog('position=' + mPosition + '; ' + msg);
    });
}

/**
 * 是否是支持的题型
 * @returns {boolean}
 */
function isSupportQuizType() {
    var modelType = qtiplayer.getModelType();
    var supportTypeArray = qtiplayer.getSupportType();
    console.log(TAG + "modelType: " + JSON.stringify(modelType) + "; supportTypeArray: " + supportTypeArray);

    for (var key in modelType) {
        var isSupport = supportTypeArray.some(function (item, index, array) {
            return item == modelType[key];
        });

        if (isSupport) {
            return true;
        }
    }
    return false;
}

var mCommentAudioObj;

function commentAudioClicked(obj, audioUrl){
    // 播放新的语音，先关闭之前的动画
    if (mCommentAudioObj != null && mCommentAudioObj != obj) {
        if(mCommentAudioObj.parentNode.className == "im-field__list im-field__list--voice is-active"){
            console.log(TAG + "commentAudioClicked() close before");
            QtiPlayerApi.stopCommentAudioAnim();
        }
    }
    mCommentAudioObj = obj;
    console.log(TAG + "commentAudioClicked()" + ", audioUrl=" + audioUrl);
    if(mCommentAudioObj.parentNode.className == "im-field__list im-field__list--voice"){
        JsNotifyApi.startCommentAudio(audioUrl);
    }else if(mCommentAudioObj.parentNode.className == "im-field__list im-field__list--voice is-active"){
        JsNotifyApi.stopCommentAudio(audioUrl);
    }
}

/**
 * 提供给原生调用的接口
 * @type {{setLock: QtiPlayerApi.setLock, showAnalyseResult: QtiPlayerApi.showAnalyseResult}}
 */
var QtiPlayerApi = {

    /**
     * 显示答案
     */
    showAnalyseResult: function () {
        qtiplayer.setLock(true, false);
        showExplain();
    },

    /**
     * 开始播放评语语音动画
     */
    startCommentAudioAnim: function (){
        console.log(TAG + "startCommentAudioAnim()");
        if (mCommentAudioObj != null) {
            mCommentAudioObj.parentNode.className = "im-field__list im-field__list--voice is-active";
        }
    },

    /**
     * 结束播放评语语音动画
     */
    stopCommentAudioAnim: function (){
        console.log(TAG + "stopCommentAudioAnim()");
        if (mCommentAudioObj != null) {
            mCommentAudioObj.parentNode.className = "im-field__list im-field__list--voice";
        }
    }
};



