MathJax.Hub.Configured();

var $request = (function request() {
    var sSearch = location.search;
    var oParam = {};
    sSearch = sSearch.substr(1, sSearch.length);
    var params = sSearch.split("&");
    for (var i = 0; i < params.length; i++) {
        var param = params[i].split("=");
        var key = param[0];
        var value = decodeURIComponent(param[1]);
        if (key in oParam) {
            (oParam[key].constructor == Array) ? oParam[key].push(value) : oParam[key] = [oParam[key], value];

        } else {
            oParam[key] = value;
        }
    }
    var fn = (function (sParamName) {
        return (oParam[sParamName]) ? oParam[sParamName] : ""
    });

    fn.get = function () {
        return oParam;
    };
    return fn;
})();

var QtiConfig = {
    responseOption: {
        refPath: '',//xml中表达式${ref-path}的实际值,默认值''
        showNum: true,//题目序号是否关闭
        showCompositeChildNum: true, //复合题子题序号是否显示
        showTitleArea: true,//是否渲染题干区，默认值true
        hideAnswerArea: false,//隐藏答案区域，默认false
        showAnswerArea: true,//渲染答案区域，默认值true
        showHint: false, //是否渲染答案提示，默认值true
        showLock: false, //是否锁定答案区,锁定后将不能再答题，默认值false
        lockMedia: false, //是否锁定多媒体
        showAnswer: true,//渲染当前的作答前情况，默认值false
        showSubSequence: true,//是否显示题目内序号（目前填空题生效）
        showCheckedAnswer: false,//渲染当前选中的答案，默认值false
        platForm: '',//接入平台,默认空，目前有：pptshell\statis
        showCorrectAnswer: false, //渲染正确的答案，默认值false
        showStatisAnswer: false,//渲染统计答案，目前支持填空题
        showMedia: true,//是否渲染多媒体，默认值true
        randomSeed: [],//选项排序种子数组(0~29不重复的随机数组)，默认[]
        expectWidth: 0,//期望答案区域宽，目前仅支持拼图题
        expectHeight: 0,//期望答案区域宽，目前仅支持拼图题
        unifyTextEntry: true,//统一填空题结构,将普通填空题处理为复合题中填空结构
        showQuestionName: true,//在题干中显示题目类型
        showCompositeSeparate: true,//显示复合题题干、内容分割栏
        skin: 'elearning'//皮肤：'wood'/'elearning' ,默认wood
    },

    analyseOption: {
        refPath: '',//xml中表达式${ref-path}的实际值,默认值''
        showNum: true,//
        showCompositeChildNum: true, //
        showTitleArea: true,//是否渲染题干区，默认值true
        hideAnswerArea: false,//隐藏答案区域，默认false
        showAnswerArea: false,//渲染答案区域，默认值true
        showHint: false, //是否渲染答案提示，默认值true
        showLock: true, //是否锁定答案区,锁定后将不能再答题，默认值false
        lockMedia: false, //是否锁定多媒体
        showAnswer: false,//渲染当前的作答前情况，默认值false
        showSubSequence: true,//是否显示题目内序号（目前填空题生效）
        showCheckedAnswer: true,//渲染当前选中的答案，默认值false
        platForm: '',//接入平台,默认空，目前有：pptshell\statis
        showCorrectAnswer: false, //渲染正确的答案，默认值false
        showStatisAnswer: false,//渲染统计答案，目前支持填空题
        showMedia: true,//是否渲染多媒体，默认值true
        randomSeed: [],//选项排序种子数组(0~29不重复的随机数组)，默认[]
        expectWidth: 0,//期望答案区域宽，目前仅支持拼图题
        expectHeight: 0,//期望答案区域宽，目前仅支持拼图题
        unifyTextEntry: true,//统一填空题结构,将普通填空题处理为复合题中填空结构
        showQuestionName: true,//在题干中显示题目类型
        showCompositeSeparate: true,//显示复合题题干、内容分割栏
        skin: 'elearning'//皮肤：'wood'/'elearning' ,默认wood
    }
};
var TAG = "ele-exp/qti: ";

window.QtiPlayer.setLoggerLevel('debug');

var mPosition = Number($request('i'));
console.log(TAG + 'createPlayer mPosition: ' + mPosition);

var mQtiType = loadQtiType();
var mQtiOption = loadQtiOption(mQtiType);
var mBeforeUserAnswerJson;

var qtiplayer = window.QtiPlayer.createPlayer(mQtiOption);

initPlayer();

function initPlayer() {
    loadQuiz(mPosition);
    loadUserAnswer(mPosition);
}
/**
 * 加载qti作答类型
 */
function loadQtiType() {
    var type = parseInt(JsDataBridgeApi.getQtiType(), 16);
    console.log(TAG + 'qtiType: ' + type);
    return type;
}

/**
 * 加载qti配置
 * @param qtiType 类型
 */
function loadQtiOption(qtiType) {
    var option;
    if (isResponseType(qtiType)) {
        option = QtiConfig.responseOption;
    } else {
        option = QtiConfig.analyseOption;
    }
    var refPath = JsDataBridgeApi.getRefPath();
    console.log(TAG + 'refPath: ' + refPath);
    option['refPath'] = refPath;
     var quizPositionIndicator = JsDataBridgeApi.getQuizPositionIndicator(mPosition);
        if(quizPositionIndicator != null){
            option['showNum'] = true;
            option['sequenceNumber'] = quizPositionIndicator;
        } else {
            option['showNum'] = false;
        }
    return option;
}

/**
 * 是否是作答模式
 * @param qtiType 模式类型
 */
function isResponseType(qtiType) {
    switch (qtiType) { //转成16进制的数
        case 0x01: //正常作答
        case 0x02: //回顾题目
        case 0x03: //做一题看一题答案
        case 0x04: //闯关模式
            return true;
        case 0x10: //错题解析
        case 0x11: //全部解析
            return false;
    }
    return false;
}

/**
 * 加载题目
 * @param position 题目位置
 */
function loadQuiz(position) {
    var quizJson = JsDataBridgeApi.getQuizJson(position);

    qtiplayer.load(quizJson, function () {
        qtiplayer.render('qtiplayer-view', mQtiOption, function () {
            console.log(TAG + 'loadQuizSuccess position: ' + position);
            var modelQuestionType = qtiplayer.getModelQuestionType();
            var autoChangePage = checkAutoChangePage(modelQuestionType);
            //var isSingleSubjectQuiz = checkSingleSubjectQuiz(modelQuestionType);

            //loadQuizSuccess 方法有依赖 onSupportQuizType 的结果
            JsNotifyApi.onLoadQuizFinish(position, isSupportQuizType(), autoChangePage);
            addUserAnswerChangeListener(autoChangePage);
            if (!isResponseType(mQtiType)) {
                showExplain();
            }
        });
    });
}

/**
 * 加载用户答案
 * @param position 题目位置
 */
function loadUserAnswer(position) {
    mBeforeUserAnswerJson = JsDataBridgeApi.getUserAnswerJson(position);
    if (mBeforeUserAnswerJson == null || mBeforeUserAnswerJson == "") {
        return;
    }
    console.log(TAG + 'loadUserAnswer: ' + mBeforeUserAnswerJson);
    qtiplayer.setAnswer(JSON.parse(mBeforeUserAnswerJson));
    qtiplayer.showAnswer();
}

/**
 * 显示解析区域
 */
function showExplain() {
    var explainJson = JsDataBridgeApi.getExplainJson(mPosition);
    console.log(TAG + "explainJson: " + explainJson);

    var explain = JSON.parse(explainJson);
    for (var index in explain) {
        var subExplain = explain[index];
        var extra = {
            modelId: subExplain["model_id"],
            extraHtml: subExplain["extra_html"]
        };

        //true为追加模式（每次调用setExtrasAnswer会在原来的基础上继续追加），
        //false不追加模式（每次调用setExtrasAnswer会清空之前追加的内容），默认为true
        qtiplayer.setExtrasAnswer(extra, true);
    }
}

/**
 * 添加答案变化监听器
 */
function addUserAnswerChangeListener(autoChangePage) {
    qtiplayer.answerOnChange(function (answer) {
        console.log(TAG + 'answerOnChange');
        var answerJson = JSON.stringify(answer);
        if (answerJson == null || answerJson == mBeforeUserAnswerJson) {
            console.log(TAG + 'need not update user answer.');
            return;
        }

        JsNotifyApi.onUserAnswerChange(mPosition, answerJson, autoChangePage);
    });
}

/**
 * 是否是支持的题型
 * @returns {boolean}
 */
function isSupportQuizType() {
    var modelType = qtiplayer.getModelType();
    var supportTypeArray = qtiplayer.getSupportType();
    console.log(TAG + "modelType: " + JSON.stringify(modelType) + "; supportTypeArray: " + supportTypeArray);

    for (var key in modelType) {
        var isSupport = supportTypeArray.some(function (item, index, array) {
            return item == modelType[key];
        });

        if (isSupport) {
            return true;
        }
    }
    return false;
}

/**
 * 单选和判断题自动翻页
 */
function checkAutoChangePage(modelQuestionType) {
    console.log(TAG + "modelQuestionType: " + JSON.stringify(modelQuestionType));

    if (modelQuestionType == null) {
        return false;
    }
    var count = 0;
    var isAutoChangePage = false;
    for (var key in modelQuestionType) {
        count++;
        var quizType = modelQuestionType[key];
        switch (quizType) {
            case "choice":
            case "judge":
                isAutoChangePage = true;
                break;
        }
    }
    return count == 1 && isAutoChangePage;
}

///**
// * 是否是主观题
// */
//function checkSingleSubjectQuiz(modelQuestionType) {
//    if (modelQuestionType == null) {
//        return false;
//    }
//    var count = 0;
//    var isSingleSubjectQuiz = true;
//    for (var key in modelQuestionType) {
//        count++;
//        var quizType = modelQuestionType[key];
//        switch (quizType) {
//            case "choice":
//            case "multiplechoice":
//            case "judge":
//                isSingleSubjectQuiz = false;
//                break;
//        }
//    }
//    return count == 1 && isSingleSubjectQuiz;
//}

/**
 * 提供给原生调用的接口
 * @type {{setLock: QtiPlayerApi.setLock, showAnalyseResult: QtiPlayerApi.showAnalyseResult}}
 */
var QtiPlayerApi = {
    /**
     * 显示答案
     * @param userAnswerResult
     */
    setLock: function () {
        qtiplayer.setLock(true, false);
    },

    /**
     * 显示答案
     * @param userAnswerResult
     */
    showAnalyseResult: function () {
        qtiplayer.setLock(true, false);
        showExplain();
    }
};



