ALTER TABLE course_exam_list ADD COLUMN course_regist_type INTEGER;
CREATE TEMPORARY TABLE course_exam_list_back(
    _id TEXT,
    course_id TEXT,
    user_id TEXT,
    title TEXT,
    duration INTEGER,
    begin_time TEXT,
    end_time TEXT,
    exam_chance INTEGER,
    passing_score INTEGER,
    total_score INTEGER,
    progress_percent_condition INTEGER,
    course_regist_type INTEGER,
    user_exam_vo TEXT,
    PRIMARY KEY (_id)
);
INSERT INTO course_exam_list_back SELECT
    _id,
    course_id,
    user_id,
    title,
    duration,
    begin_time,
    end_time,
    exam_chance,
    passing_score,
    total_score,
    progress_percent_condition,
    course_regist_type,
    user_exam_vo
    FROM course_exam_list;
DROP TABLE course_exam_list;
CREATE TABLE course_exam_list(
    _id TEXT,
    course_id TEXT,
    user_id TEXT,
    title TEXT,
    duration INTEGER,
    begin_time TEXT,
    end_time TEXT,
    exam_chance INTEGER,
    passing_score INTEGER,
    total_score INTEGER,
    progress_percent_condition INTEGER,
    course_regist_type INTEGER,
    user_exam_vo TEXT,
    PRIMARY KEY (_id, course_id, user_id)
);
INSERT INTO course_exam_list SELECT
    _id,
    course_id,
    user_id,
    title,
    duration,
    begin_time,
    end_time,
    exam_chance,
    passing_score,
    total_score,
    progress_percent_condition,
    course_regist_type,
    user_exam_vo
    FROM course_exam_list_back;
DROP TABLE course_exam_list_back;
CREATE TEMPORARY TABLE course_info_back(
    _id TEXT,
    user_id TEXT,
    title TEXT,
    pic_id INTEGER,
    pic_url TEXT,
    video_id INTEGER,
    video_url TEXT,
    user_count INTEGER,
    user_suit TEXT,
    description TEXT,
    course_status INTEGER,
    total_time INTEGER,
    effective_time INTEGER,
    course_regist_type INTEGER,
    user_regist_status INTEGER,
    resource_type_info TEXT,
    video_count INTEGER,
    document_count INTEGER,
    exercise_count INTEGER,
    exam_count INTEGER,
    single_resource INTEGER,
    PRIMARY KEY(_id)
);
INSERT INTO course_info_back SELECT
    _id,
    user_id,
    title,
    pic_id,
    pic_url,
    video_id,
    video_url,
    user_count,
    user_suit,
    description,
    course_status,
    total_time,
    effective_time,
    course_regist_type,
    user_regist_status,
    resource_type_info,
    video_count,
    document_count,
    exercise_count,
    exam_count,
    single_resource
    FROM course_info;
DROP TABLE course_info;
CREATE TABLE course_info(
    _id TEXT,
    user_id TEXT,
    title TEXT,
    pic_id INTEGER,
    pic_url TEXT,
    video_id INTEGER,
    video_url TEXT,
    user_count INTEGER,
    user_suit TEXT,
    description TEXT,
    course_status INTEGER,
    total_time INTEGER,
    effective_time INTEGER,
    course_regist_type INTEGER,
    user_regist_status INTEGER,
    resource_type_info TEXT,
    video_count INTEGER,
    document_count INTEGER,
    exercise_count INTEGER,
    exam_count INTEGER,
    single_resource INTEGER,
    PRIMARY KEY(_id, user_id)
);
INSERT INTO course_info SELECT
    _id,
    user_id,
    title,
    pic_id,
    pic_url,
    video_id,
    video_url,
    user_count,
    user_suit,
    description,
    course_status,
    total_time,
    effective_time,
    course_regist_type,
    user_regist_status,
    resource_type_info,
    video_count,
    document_count,
    exercise_count,
    exam_count,
    single_resource
    FROM course_info_back;
DROP TABLE course_info_back;